import sys, os, os.path

try:
    (target,) = sys.argv[1:]
except:
    print """spyceProject automates the creation of new Spyce projects.
Usage: spyceProject <target directory>
e.g., spyceProject /var/firstproject"""
    os.exit()

if os.path.exists(target):
    print "Error: %s already exists!" % target
    os.exit()

try:
    os.makedirs(target)
except:
    print """Error creating %s.
Most likely you do not have appropriate permissions.""" % target
    os.exit()

for subdir in ['www', 'lib']:
    os.mkdir(os.path.join(target, subdir))

# write spyceconf
spyceconf = """
from spyceconf import *

# The root option defines the path from which Spyce requests are processed.
# I.e., when a request for http://yourserver/path/foo.spy arrives,
# Spyce looks for foo.spy in <root>/path/.
root = r'%s'
# This allows you to import .py modules from the lib directory.
sys.path.append(r'%s')

# Some commonly overridden options -- see spyceconf.py from the Spyce
# distribution for details and the full set of options.
debug = True         # False to log less to stderr
port = 8000          # webserver port
indexExtensions = [] # list of extensions to check if directory requested, e.g. ['spy']
""" % (os.path.join(target, 'www'), os.path.join(target, 'lib'))
open(os.path.join(target, 'spyceconf.py'), 'w').write(spyceconf)

# write index skeleton
index = """
<spy:parent title="Welcome" />

Welcome to your new Spyce project!  Feel free to join
<a href=http://sourceforge.net/mailarchive/forum.php?forum_id=10008>the mailing list</a>
and ask any questions you have.
"""
open(os.path.join(target, 'www', 'index.spy'), 'w').write(index)

# write parent skeleton
parent = """
<html>
  <head>
    <title>[[= child.title ]]</title>
  </head>

  <body>
    <h1>[[= child.title ]]</h1>
    <hr>

    [[= child._body ]]
    
  </body>
</html>
"""
open(os.path.join(target, 'www', 'parent.spi'), 'w').write(parent)

# all done
print "Successfully created project skeleton at %s" % target
